

package com.ibm.sysmgt.raidmgr.cim.provider.association;

import com.ibm.sysmgt.raidmgr.cim.provider.instance.*;

import java.io.*;
import java.util.*;
import java.rmi.RemoteException;

import com.sun.wbem.cim.*;
import com.sun.wbem.provider20.AssociatorProvider;

import com.ibm.sysmgt.raidmgr.dataproc.config.*;
import com.ibm.sysmgt.raidmgr.dataproc.util.*;
import com.ibm.sysmgt.raidmgr.util.*;

public class AssociatorRAIDDriveInDiskArray extends RAIDAssociatorProviderBase
{
   public AssociatorRAIDDriveInDiskArray()
   {
      super("AssociatorRAIDDriveInDiskArray:", "IBMPSG_RAIDDriveInDiskArray");
      associationLog.println(logHeader + "AssociatorRAIDDriveInDiskArray()");
   }

   protected Vector associatorHelper(CIMObjectPath assocName, CIMObjectPath objectName, String resultClass, 
                                 String role, String resultRole) throws CIMException
   {
      return new Vector();
   }


   protected Vector referenceHelper(CIMObjectPath assocName, CIMObjectPath objectName, String role) throws CIMException
   {
      return new Vector();
   }

   //**************************************************************************************************************
   // Now for the InstanceProvider implementation (for Windows)
   //**************************************************************************************************************
   public Vector enumInstances(CIMObjectPath op, boolean deep, CIMClass cc, boolean localOnly) throws CIMException
   {
      associationLog.println(logHeader + "enumInstances(" + op.getObjectName() + ")");

      if (!op.getObjectName().trim().equalsIgnoreCase(CIM_CREATION_CLASS_NAME))
      {
         associationLog.println(logHeader + "Does not provide instances of class " + op.getObjectName());         
         throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
      }

      SetInteractiveWSAD();
      
      Vector instances = new Vector();

      RaidSystem system = null;
      try
      {         
         system = (RaidSystem)getRaidSystem();
      }
      catch (RemoteException e)
      {
         associationLog.println(logHeader + "Error accessing the ServeRAID Manager agent. Exception: " + e);
         RestoreInteractiveWSAD();
         throw new CIMException(CIMException.CIM_ERR_FAILED);
      }

      for (Enumeration e = system.enumerateAdapters(); e.hasMoreElements();)
      {
         Adapter adapter = (Adapter)e.nextElement();
         for (Enumeration e2 = adapter.getArrayCollection(null).elements(); e2.hasMoreElements();)
         {
            Array array = (Array)e2.nextElement();
            for (Enumeration e3 = array.getPhysicalDeviceCollection(new PhysicalDeviceTypeFilter(Constants.HARD_DRIVE)).elements(); e3.hasMoreElements();)
            {
               HardDrive drive = (HardDrive)e3.nextElement();
               instances.addElement(drive.createRAIDDriveInDiskArrayAssociation(cc.newInstance()));
            }
         }         
      }

      RestoreInteractiveWSAD();

      return instances;
   }

   public Vector enumInstances(CIMObjectPath op, boolean deep, CIMClass cc) throws CIMException
   {
      associationLog.println(logHeader + "enumInstances(" + op.getObjectName() + ") Names Only");

      if (!op.getObjectName().equalsIgnoreCase(CIM_CREATION_CLASS_NAME))
      {
         associationLog.println(logHeader + "Does not provide names of class " + op.getObjectName());         
         throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
      }

      SetInteractiveWSAD();

      Vector cops = new Vector();
      Vector instances = new Vector();

      RaidSystem system = null;
      try
      {         
         system = (RaidSystem)getRaidSystem();
      }
      catch (RemoteException e)
      {
         associationLog.println(logHeader + "Error accessing the ServeRAID Manager agent. Exception: " + e);
         RestoreInteractiveWSAD();
         throw new CIMException(CIMException.CIM_ERR_FAILED);
      }

      for (Enumeration e = system.enumerateAdapters(); e.hasMoreElements();)
      {
         Adapter adapter = (Adapter)e.nextElement();
         for (Enumeration e2 = adapter.getArrayCollection(null).elements(); e2.hasMoreElements();)
         {
            Array array = (Array)e2.nextElement();

            for (Enumeration e3 = array.getPhysicalDeviceCollection(new PhysicalDeviceTypeFilter(Constants.HARD_DRIVE)).elements(); e3.hasMoreElements();)
            {
               HardDrive drive = (HardDrive)e3.nextElement();
               instances.addElement(drive.createRAIDDriveInDiskArrayAssociation(cc.newInstance()));
            }
         }         
      }

      for (Enumeration e = instances.elements(); e.hasMoreElements();)
      {
         CIMInstance ci = (CIMInstance)e.nextElement();
         CIMObjectPath cop = new CIMObjectPath(cc.getName(), op.getNameSpace());
         cop.setKeys(ci.getKeyValuePairs());
         cops.addElement(cop);
      }

      RestoreInteractiveWSAD();
      return cops;
   }

   public CIMInstance getInstance(CIMObjectPath op, CIMClass cc, boolean localOnly) throws CIMException
   {
      associationLog.println(logHeader + "getInstance(" + op.getObjectName() + ")");

      if (!op.getObjectName().equalsIgnoreCase(CIM_CREATION_CLASS_NAME))
      {
         associationLog.println(logHeader + "Does not provide instances of class " + op.getObjectName());         
         throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
      }

      CIMInstance instance = cc.newInstance();

      instance.setProperty("Collection", new CIMValue((CIMObjectPath) getKeyValue(op, "Collection")));
      instance.setProperty("Member", new CIMValue((CIMObjectPath) getKeyValue(op, "Member")));

      return instance;
   }
}
